<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Password Encryption Rule</title>
</head>
<body>
<p>This rule checks for the usage of <code>PasswordEncoder</code> in methods with names containing 'Security', 'User', 'Account', 'JWT', or 'password' within Java code. It ensures that passwords are properly encoded before being stored or processed.</p>

<h2>Noncompliant Code Example</h2>
<pre>
package com.example;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class UserController {

  @PostMapping("/createUser")
  public void createUser(String username, String password) {
    // Noncompliant
    // Code to create user
  }

  @PostMapping("/updatePassword")
  public void updatePassword(String username, String newPassword) {
    // Noncompliant
    // Code to update password
  }
}
</pre>

<h2>Compliant Solution</h2>
<pre>
package com.example;

import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class UserController {

  private final PasswordEncoder passwordEncoder = new BCryptPasswordEncoder();

  @PostMapping("/createUser")
  public void createUser(String username, String password) {
    String encodedPassword = passwordEncoder.encode(password); // Compliant: Password is encoded
    // Code to create user with encoded password
  }

  @PostMapping("/updatePassword")
  public void updatePassword(String username, String newPassword) {
    String encodedPassword = passwordEncoder.encode(newPassword); // Compliant
    // Code to update password with encoded password
  }
}
</pre>
</body>
</html>
